#ifndef _myOPENGL_Class
#define _myOPENGL_Class

#include <gl\gl.h>      // Header file for the OpenGL32 library
#include <gl\glu.h>     // Header file for the GLu32 library
#include <gl\glaux.h>   // Header file for the GLaux library
#include <cstdio>
#include <queue>
//#include <vcl.h>
using namespace std;


struct myVector{
	float x,y,z;
};


void flipIt(void* buffer)	// Flips the red and blue bytes (256x256)
		{
			void* b = buffer;	// Pointer to the buffer
			__asm			// Assembler code to follow
			{
				mov ecx, 512*512        	// Counter set to dimensions of our memory block
				mov ebx, b	        	// Points ebx to our data (b)
				label:		        	// Label used for looping
				mov al,[ebx+0]  	// Loads value at ebx into al
				mov ah,[ebx+2]  	// Loads value at ebx+2 into ah
				mov [ebx+2],al	        // Stores value in al at ebx+2
				mov [ebx+0],ah		// Stores value in ah at ebx

				add ebx,3		// Moves through the data by 3 bytes
				dec ecx			// Decreases our loop counter
				jnz label		// If not zero jump back to label
		}
}


class MyOpenGLPanel:public TCustomPanel{
	__published:
		   __property Caption;
		   __property Alignment;
		   __property Align;
		   __property DragCursor;
		   __property DragMode;
		   __property Enabled;
		   __property ParentFont;
		   __property ParentShowHint;
		   __property PopupMenu;
		   __property ShowHint;
		   __property TabOrder;
		   __property TabStop;
		   __property Visible;
		   __property OnMouseDown;
		   __property OnMouseUp;
		   __property OnMouseMove;
		   __property OnKeyDown;
		   __property OnKeyUp;
		   __property OnKeyPress;

	private:
	   Graphics::TBitmap *tmpTextureImage[1];
	public:
		HDC  hdc;
		HGLRC hrc;
		int PixelFormat;
		GLuint texture[1];
		Graphics::TBitmap* TextureImage[1];
		//
		GLuint filter;						// Which Filter To Use
		GLuint fogMode[3];//= { GL_EXP, GL_EXP2, GL_LINEAR };	// Storage For Three Types Of Fog
		GLuint fogfilter;					// Which Fog To Use
		GLfloat fogColor[4];//= {0.5f, 0.5f, 0.5f, 1.0f};		// Fog Color
		//

		void (*RenderGLScene)(MyOpenGLPanel *Owner);


		__fastcall MyOpenGLPanel( TComponent* Owner )
			: TCustomPanel( Owner )
		{
//			 _control87(MCW_EM, MCW_EM);
			TextureImage[0] = new Graphics::TBitmap;
//		   TextureImage[0]->LoadFromFile("NeHe.bmp");
		TextureImage[0]->Width=512;
		TextureImage[0]->Height=512;
		TextureImage[0]->PixelFormat=pf24bit;

		   fogMode[0]=GL_EXP;
		   fogMode[1]=GL_EXP2;
		   fogMode[2]=GL_LINEAR;
		   fogColor[0]=0.5f;
		   fogColor[1]=0.5f;
		   fogColor[2]=0.5f;
		   fogColor[3]=1.0f;
		   fogfilter=1;
		   tmpTextureImage[0]=new Graphics::TBitmap;

		}
		void __fastcall CreateParams(TCreateParams &Params)
		{
//			// եΤơAӨ~ӦTWindowControl
			TCustomPanel::CreateParams(Params);
			Params.Style |= (WS_CLIPCHILDREN | WS_CLIPSIBLINGS);
		}
		void __fastcall GL_Initialize()
		{
			// Must be call before any operation!
			hdc = GetDC(this->Handle);
			SetPixelFormatDescriptor();
			hrc = wglCreateContext(hdc);
			wglMakeCurrent(hdc, hrc);
//			SetupRC();
			//
			if (!LoadGLTextures())                  // Jump to texture loading routine ( NEW )
			{
				ShowMessage("fail to load texture.");
				return ;                   // If texture didn't load return FALSE ( NEW )
			}
			glEnable(GL_TEXTURE_2D);                // Enable texture mapping ( NEW )
			glShadeModel(GL_SMOOTH);                // Enable smooth shading
			glClearColor(0.0f, 0.0f, 0.0f, 0.5f);   // Black background
			glClearDepth(1.0f);                     // Depth buffer setup
			glEnable(GL_DEPTH_TEST);                // Enables depth testing
			glDepthFunc(GL_LEQUAL);                 // The type of depth testing to do
			glHint(GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST);      // Really nice perspective calculations

			/*glFogi(GL_FOG_MODE, fogMode[fogfilter]);		// Fog Mode


	glClearColor(0.5f,0.5f,0.5f,1.0f);			// We'll Clear To The Color Of The Fog ( Modified )
glFogfv(GL_FOG_COLOR, fogColor);			// Set Fog Color
glFogf(GL_FOG_DENSITY, 0.65f);				// How Dense Will The Fog Be
glHint(GL_FOG_HINT, GL_DONT_CARE);			// Fog Hint Value
glFogf(GL_FOG_START, 1.5f);				// Fog Start Depth
glFogf(GL_FOG_END, -1.5f);				// Fog End Depth
glEnable(GL_FOG);					// Enables GL_FOG*/


        	CanvasResize(this);
		}
		void __fastcall SetupRC()
		{
			glClearColor(1.0f, 1.0f, 1.0f, 1.0f);
			glClear(GL_COLOR_BUFFER_BIT);
			glFlush();
		}
		__fastcall ~MyOpenGLPanel()
		{
			ReleaseDC(Handle,hdc);
			wglMakeCurrent(hdc, NULL);
			wglDeleteContext(hrc);
			delete TextureImage[0];
			delete tmpTextureImage[0];
		}
		void __fastcall SetPixelFormatDescriptor()
		{
			PIXELFORMATDESCRIPTOR pfd = {
				sizeof(PIXELFORMATDESCRIPTOR),
				1,
				PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL | PFD_DOUBLEBUFFER,
				PFD_TYPE_RGBA,
				24,
				0,0,0,0,0,0,
				0,0,
				0,0,0,0,0,
				32,
				0,
				0,
				PFD_MAIN_PLANE,
				0,
				0,0,0
				};
			PixelFormat = ChoosePixelFormat(hdc, &pfd);
			SetPixelFormat(hdc, PixelFormat, &pfd);
		}
		void __fastcall Paint()
		{
/*			RenderGLScene(this);
			this->Canvas->Font->Color = clBlack;
			this->Canvas->Font->Size =18;
			this->Canvas->TextOutA(0,0,"Hello World!");*/
//			RenderGLScene(this);
		}
		void __fastcall GL_Paint()
		{
//			done=false;
			RenderGLScene(this);
	    	SwapBuffers(hdc);
		}
/*		void __fastcall RenderGLScene()
		{
			 //Place your OpenGL drawing code here
		}*/
		/*for test.*/
		AUX_RGBImageRec *LoadBMP(char *Filename)        // Loads a bitmap image
		{
			FILE *File = NULL;              // File handle
			if (!Filename)		        // Make sure a filename was given
			{
				return NULL;	        // If not return NULL
			}
			File = fopen(Filename,"r");	// Check to see if the file exists
			if (File)			// Does the file exist?
			{
				fclose(File);		// Close the handle
				return auxDIBImageLoad(Filename);       // Load the bitmap and return a pointer
			}
			return NULL;                    // If load failed return NULL
		}
		int zLoadGLTextures()    // Load bitmaps and convert to textures
		{
			int Status = false;     // Status indicator

			AUX_RGBImageRec *TextureImage[1];               // Create storage space for the texture

			memset(TextureImage,0,sizeof(void *)*1);        // Set the pointer to NULL

			// Load the bitmap, check for errors, if bitmap's not found quit
			if (TextureImage[0]=LoadBMP("NeHe.bmp"))
			{
				Status = true;				// Set the status yo TRUE

				glGenTextures(1, &texture[0]);		// Create the texture

				// Typical texture generation using data from the bitmap
				glBindTexture(GL_TEXTURE_2D, texture[0]);
				glTexImage2D(GL_TEXTURE_2D, 0, 3, TextureImage[0]->sizeX, TextureImage[0]->sizeY, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->data);
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
				glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
			}
			if (TextureImage[0])			// If texture exists
			{
				if (TextureImage[0]->data)	// If texture image exists
				{
					free(TextureImage[0]->data);	// Free the texture image memory
				}

				free(TextureImage[0]);			// Free the image structure
			}

			return Status;				// Return the status
		}
		Graphics::TBitmap* glCanvas()
		{
			return TextureImage[0];
		}
		void MyTextOut()
		{
			TextureImage[0]->Canvas->TextOutA(20,20,"Hello World!");
		}
		void BGR_to_RGB(Graphics::TBitmap *origbmp)
		{
			int x,y,bmph,bmpw,R,G,B;
			origbmp->PixelFormat =pf24bit;
			Byte *ptr=NULL;
			bmph = origbmp->Height ;
			bmpw= origbmp->Width ;
			for(y=0;y< bmph ;y++){
				ptr = (Byte *)origbmp->ScanLine[y];
				for (x = 0;x < bmpw ;x++ ) {
					R = ptr[ x * 3 + 2 ];
	//				G = ptr[ x * 3 + 1 ];
					B = ptr[ x * 3 ];
					ptr[x*3+2]=B;
					ptr[x*3]=R;
				}
			}
		}

		void myUpdate()
		{
//        	ShowMessage("!");
		   tmpTextureImage[0]->Assign(TextureImage[0]);
		   //BGR_to_RGB(tmpTextureImage[0]);
			flipIt( (void *)tmpTextureImage[0]->ScanLine[tmpTextureImage[0]->Width-1] );		   
			glTexSubImage2D (GL_TEXTURE_2D, 0, 0, 0, 512, 512, GL_RGB, GL_UNSIGNED_BYTE,tmpTextureImage[0]->ScanLine[tmpTextureImage[0]->Width-1] );
		}
		int LoadGLTextures()    // Load bitmaps and convert to textures
		{
		   int Status = false;
//		   Graphics::TBitmap *tmpTextureImage[1];
		//this->MyTextOut();
//		   glDisable( GL_TEXTURE_2D );

//		   tmpTextureImage[0]=new Graphics::TBitmap;
		   tmpTextureImage[0]->Assign(TextureImage[0]);
		   //BGR_to_RGB(tmpTextureImage[0]);
		   flipIt( (void *)tmpTextureImage[0]->ScanLine[tmpTextureImage[0]->Width-1] );


//		   ShowMessage("load bmp");
//		   if(tmpTextureImage[0]) {
			 Status = true;
			 glGenTextures(1, &texture[0]);
			 glBindTexture(GL_TEXTURE_2D, texture[0]);
/*			 glTexImage2D(GL_TEXTURE_2D, 0, 3,
			 TextureImage[0]->Width,
			 TextureImage[0]->Height, 0, GL_RGB, GL_UNSIGNED_BYTE, TextureImage[0]->ScanLine);*/
//			 ShowMessage("load bmp pp1!");
			glTexImage2D(GL_TEXTURE_2D, 0, 3,
			   tmpTextureImage[0]->Width,
			   tmpTextureImage[0]->Height, 0, GL_RGB, GL_UNSIGNED_BYTE,
			   tmpTextureImage[0]->ScanLine[tmpTextureImage[0]->Width-1]);
//			ShowMessage("load bmp pp2!");
			 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);
			 glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
		   glEnable( GL_TEXTURE_2D );
//		}
//		if (tmpTextureImage[0])			// If texture exists
//		{
//			 if(TextureImage[0])
//				 TextureImage[0]->ReleaseHandle();
//			 delete tmpTextureImage[0];
//		}
//	   ShowMessage("load bmp ok!");
		return Status;				// Return the status
	}
	myVector& GetOGLPos(int x, int y)
	{
		static myVector result;
		GLint viewport[4];
		GLdouble modelview[16];
		GLdouble projection[16];
		GLfloat winX, winY, winZ;
		GLdouble posX, posY, posZ;

		glGetDoublev( GL_MODELVIEW_MATRIX, modelview );
		glGetDoublev( GL_PROJECTION_MATRIX, projection );
		glGetIntegerv( GL_VIEWPORT, viewport );

		winX = (float)x;
		winY = (float)viewport[3] - (float)y;
		glReadPixels( x, int(winY), 1, 1, GL_DEPTH_COMPONENT, GL_FLOAT, &winZ );

		gluUnProject( winX, winY, winZ, modelview, projection, viewport, &posX, &posY, &posZ);
	//	ShowMessage(posX);
		result.x = posX;
		result.y = posY;
		result.z = posZ;
		return result;
	//	ShowMessage(AnsiString(x)+","+AnsiString(y));

	//	return CVector3(posX, posY, posZ);
	}
	void __fastcall CanvasResize(TObject *Sender)
	{
    	int height=Height,width=Width;
		if (height == 0)                        // Prevent A Divide By Zero By
		{
				height = 1;                     // Making height equal One
		}

		glViewport(0, 0, width, height);        // Reset the current viewport

		glMatrixMode(GL_PROJECTION);            // Select the projection matrix
	glLoadIdentity();                       // Reset the projection matrix

	// Calculate the aspect ratio of the window
	gluPerspective(45.0f,(GLfloat)width/(GLfloat)height,0.1f,100.0f);

	glMatrixMode(GL_MODELVIEW);             // Select the modelview matrix
	glLoadIdentity();                       // Reset the modelview matrix
	}

};



struct _MyMapStruct{
	unsigned char Index,X,Y;
	short objflag;
	unsigned int flag;
};
struct _MyImageSource{
	int X,Y;
};

class myImageArrayLoader{
	public:
		Graphics::TBitmap *bmpMain;
		int subWidth,subHeight;
		char name[8+1];
		myImageArrayLoader()
		{
			memset( name ,0,sizeof(name) );
			bmpMain= new Graphics::TBitmap;
		}
		~myImageArrayLoader()
		{
			if( bmpMain )
				delete bmpMain;
		}
		void GetSubImage(int x,int y,Graphics::TBitmap *destbmp)
		{
			int sx,sy;
			sx=(x-1)*subWidth;
			sy=(y-1)*subHeight;
			destbmp->PixelFormat =pf24bit;
			destbmp->Height = subHeight;
			destbmp->Width = subWidth;
			::BitBlt(destbmp->Canvas->Handle ,0,0,subWidth,subHeight,
				bmpMain->Canvas->Handle,sx,sy,SRCCOPY );
		}

};

class MyAniGraphic{
	public:
		//Graphics::TBitmap *bmpList[8];
		myImageArrayLoader *ImageArrayPtr[16];
		int MainBmpIndex;
		_MyImageSource ImageSourceList[8];
		int Interval;
		int Amount; // number of images exist.
		int TickCount;
		bool Enabled;
		int LockAtIndex;
		int Iteration;
		int PlayingIndex;
		MyAniGraphic()
		{
			int i;
			for(i=0;i<8;i++){
//				ImageSourceList[i].Index=0;
				ImageSourceList[i].X=0;
				ImageSourceList[i].Y=0;

			}
			Amount=0;
			Enabled=false;
			TickCount=0;
			LockAtIndex=0;
			Iteration=0;
			PlayingIndex=0;
		}
		~MyAniGraphic()
		{
        	;
		}
		void GetFrameImage(int FrameIndex,Graphics::TBitmap *destbmp)
		{
			ImageArrayPtr[MainBmpIndex]->GetSubImage( ImageSourceList[FrameIndex].X ,
										ImageSourceList[FrameIndex].Y ,
										destbmp );
		}
		void Clear()
		{
			int i;
			for(i=0;i<8;i++){
//				ImageSourceList[i].Index=0;
				ImageSourceList[i].X=0;
				ImageSourceList[i].Y=0;

			}
		}
};



#define MaxMapW 400
#define MaxMapH 400

#define MaxViewWidth 16
#define MaxViewHeight 12


// define for action op code
#define _WalkAhead 5
#define _JumpUp 9
#define _SetFace 6
#define _SetX 7
#define _SetY 8



class MyOnlineRPG{
	public:
		_MyMapStruct MapData[MaxMapW][MaxMapH];
		Graphics::TBitmap *MapImage;
		MyOpenGLPanel *glpanelPtr;
		Graphics::TBitmap *FrameEdgeImage;

		int GridPixelWidth,GridPixelHeight;
		int svX,svY;  //W
		int charaX,charaY;
		myImageArrayLoader GridImage[16];
		myImageArrayLoader CharaImage[16];
		myImageArrayLoader ObjectImage[16];
		myImageArrayLoader OtherImage[8];
		//
		vector<AnsiString> ChatMsgQueue;
		//Temp buffer
		Graphics::TBitmap *bmpBuffer;
		class MyCharacter{
			public:
				MyAniGraphic AniImage[8];
				struct MyActionCode{
					int opcode;
					int arg1,arg2,arg3;
				};
				::queue<MyActionCode> ActionQueue;
				// CӤH8ذʵe, and CӰʵe̦h8 frames
				// e|elementxs樫Ϫ樫Vʵe,Fn_
				int AG_Count; //ʵeƥ
				int Visible;
				bool Exist;
				int FaceDirect; //Hy¦VV
				int NowPlayIndex; //ثen񨺭Ӱʵe
				// 2006.5.18ץ
				int X,Y;// ӤHbaϤW@
				// Fe
				// CGridAΦ4cell(V4ӪV4)
				int numobj;

				bool LockCamera;
				int PixelOffsetX,PixelOffsetY;
				char name[25];
				int uniqueid; //Cclient|o@Ӱߤ@ID
				int futureX,futureY;//2006.6.19 s[JAbfs쪺ӮyI
				MyCharacter()
				{
					AG_Count=0;
					Exist=false;
					PixelOffsetX=PixelOffsetY=0;
//					RPGSystem = Owner;
					LockCamera=false;
					uniqueid=-100;
					numobj=0;
					futureX=futureY=0;
					
					memset(name,0,sizeof(name));
				}
/*				void Init(MyOnlineRPG *rpgsys)
				{
					RPGSystem=rpgsys;
					ShowMessage("!");
				}*/
				~MyCharacter()
				{
					ClearActionQueue();
				}
				void ClearActionQueue()
				{
					while( !ActionQueue.empty() )
						ActionQueue.pop();
				}
/*				void ViewMe()
				{
					int nx,ny;
					nx=X- MaxViewWidth /2;
					ny=Y- MaxViewHeight /2;
					if( nx<0 ) nx=0;
					if( ny<0 ) ny=0;
//					RPGSystem->svX=RPGSystem->svX;
					ShowMessage( RPGSystem->svX );
//					RPGSystem->svX = nx;
//					RPGSystem->svY = ny;
				}*/
				void JumpUp()
				{
					MyActionCode myac;
					myac.opcode=_JumpUp;
					myac.arg1=myac.arg2=0;
					myac.arg3=0;
					ActionQueue.push(myac);
				}
				void Walk(int direct)
				{
					//2006.6.19ץ
					if( LockCamera ){
						if( direct==0 && Y-1< 0 ) return;
						else if( direct==1 && X+1>=MaxMapW ) return;
						else if( direct==2 && Y+1>=MaxMapH ) return;
						else if( direct==3 && X-1<0 ) return;
					}
					MyActionCode myac;
					myac.opcode=_WalkAhead;
					myac.arg1=myac.arg2=5;
					myac.arg3=direct;
					ActionQueue.push(myac);

				}
		};
		MyCharacter chara[32];
		class MyObject{
			public:
				MyAniGraphic AniImage[2];
				int AG_Count; //ʵeƥ
				int Visible;
				bool Exist;
				int NowPlayIndex; //ثen񨺭Ӱʵe
				bool TimeFlag;
				// 2006.5.18ץ
				int X,Y;// ӤHbaϤW@;
				MyObject()
				{
					AG_Count=0;
					Exist=false;
					TimeFlag=false;
				}
				~MyObject()
				{
				}
		};
		MyObject obj[64]; //i64_

		MyOnlineRPG(MyOpenGLPanel *ogl_panel)
		{
//			GridImage.subWidth=16;
//			GridImage.subHeight=16;
			bmpBuffer = new Graphics::TBitmap;
			MapImage = ogl_panel->glCanvas() ;
			register int i,j;
			for(i=0;i<MaxMapW;i++)
				for(j=0;j<MaxMapH;j++){
						MapData[i][j].Index=0;
						MapData[i][j].X=1;
						MapData[i][j].Y=1;
						MapData[i][j].flag=0;
						MapData[i][j].objflag=-1;
					}
			glpanelPtr=ogl_panel;
			FrameEdgeImage=new Graphics::TBitmap;

		}
		~MyOnlineRPG()
		{
			if( bmpBuffer!=NULL ) delete bmpBuffer;
			if( FrameEdgeImage!=NULL ) delete FrameEdgeImage;
		}
/*		void Chara_Walk(int which,int direct)
		{
			if( direct==0 && Y-1< 0 ) return;
			else if( direct==1 && X+1>=MaxMapW ) return;
			else if( direct==2 && Y+1>=MaxMapH ) return;
			else if( direct==3 && X-1<0 ) return;

		}*/
		bool Chara_GoTo(int which,int tx,int ty)
		{
			int i,j,k;
			int dx[]={0,-1,1,0};
			int dy[]={-1,0,0,1};
			int nx,ny;
			struct MyQueue{
				int x,y;
				int level;
				int direct;
				int parent;
			};
			static struct MyQueue myq[4097];
			static int mark[MaxMapW+1][MaxMapH+1];
			static int thisTimes;
			static char path[4097];
			int head,tail;

/*			if( chara[which].ActionQueue.size()>10 ){
				chara[which].X=tx;
				chara[which].Y=ty;
			}*/

//			int myq_count;
			thisTimes++;
			head=0;
			tail=1;
			if( chara[which].futureX==tx && chara[which].futureY==ty )
				return true;
			if( chara[which].X==tx && chara[which].Y==ty )
				return true;



			myq[0].x= chara[which].futureX ;
			myq[0].y= chara[which].futureY;
			myq[0].level=0;
			myq[0].parent=-1;
			mark[myq[0].x][myq[0].y]=thisTimes;
			do{
				for( i=0 ; i<4 ; i++ ){
					nx=dx[i]+myq[head].x;
					ny=dy[i]+myq[head].y;
					if( nx>=0&&ny>=0&&nx<MaxMapW&&ny<MaxMapH
						&& mark[nx][ny]!=thisTimes	&& MapData[nx][ny].flag!=1 ){
						myq[tail].x=nx;
						myq[tail].y=ny;
						myq[tail].level=myq[head].level+1;
						myq[tail].direct=i;
						myq[tail].parent = head;
						mark[nx][ny]=thisTimes;
						if( nx==tx && ny==ty ){
							goto Finish_Job;
						}
						tail++;
					}
				}
				head++;
				if( head+1>=4096 || tail+1>=4096 ){
					//|iणsb,άOiӻ
					break;
				}
			}while( head<tail );
			//|iणsb,άOiӻ
			//wؼЮl
			//2006.6.19 ץAMaction queue
			while(!chara[which].ActionQueue.empty())
				chara[which].ActionQueue.pop();
			chara[which].X=tx;
			chara[which].Y=ty;
			chara[which].futureX =tx;
			chara[which].futureY =ty;
			return false;
			Finish_Job:
				chara[which].futureX =tx;
				chara[which].futureY =ty;
				//CX|
				path[0]=0;
				for( i=tail,j=0 ; i!=-1 ; i=myq[i].parent,j++ ){
					if( myq[i].parent==-1 ) break;

					if( myq[i].direct==0 ){
						path[j]='U';
					}else if( myq[i].direct==1 ){
						path[j]='L';
					}else if( myq[i].direct==2 ){
						path[j]='R';
					}else if( myq[i].direct==3 ){
						path[j]='D';
					}
				}
				path[j]=0;
				for(i=j-1;i>=0;i--){
					if( path[i]=='U' )
						chara[which].Walk(0);
					else if( path[i]=='R' )
						chara[which].Walk(1);
					else if( path[i]=='D' )
						chara[which].Walk(2);
					else if( path[i]=='L' )
						chara[which].Walk(3);
				}
			chara[which].futureX =tx;
			chara[which].futureY =ty;
				return true;
		}

		void ExecuteAction(int which)
		{
			MyCharacter::MyActionCode myac;
			int i;
			int& X=chara[which].X;
			int& Y=chara[which].Y;
			while( !chara[which].ActionQueue.empty() ){
//                    	ShowMessage("!");
				myac = chara[which].ActionQueue.front();
				switch( myac.opcode ){
					case _WalkAhead: //@B( |@ )
						{

							chara[which].NowPlayIndex=myac.arg3;
							chara[which].FaceDirect=myac.arg3;
							if( chara[which].FaceDirect==0 ){
								if( Y-1<0 ) Y=1;
								if( MapData[X][Y-1].flag==1 ){
									if( !chara[which].ActionQueue.empty() )
										chara[which].ActionQueue.pop();
									continue;
								}
							}else if( chara[which].FaceDirect==1 ){
								if( X+1>=MaxMapW ) X=MaxMapW-1;
								if( MapData[X+1][Y].flag==1 ){
									if( !chara[which].ActionQueue.empty() )
										chara[which].ActionQueue.pop();
									continue;
								}
							}else if( chara[which].FaceDirect==2 ){
								if( Y+1>=MaxMapH ) Y=MaxMapH-1;
								if( MapData[X][Y+1].flag==1 ){
									if( !chara[which].ActionQueue.empty() )
										chara[which].ActionQueue.pop();
									continue;
								}
							}else if( chara[which].FaceDirect==3 ){
								if( X-1<0 ) X=1;

								if(MapData[X-1][Y].flag==1 ){
									if( !chara[which].ActionQueue.empty() )
										chara[which].ActionQueue.pop();
									continue;
								}
							}

/*									for(i=0;i<AG_Count;i++){
								AniImage[i].Enabled=false;
							}*/

							chara[which].AniImage[chara[which].NowPlayIndex].Enabled=true;
							if( chara[which].FaceDirect==0 ){
								chara[which].PixelOffsetX=0;
								chara[which].PixelOffsetY=-(24/myac.arg2)*(myac.arg2-myac.arg1+1);
							}else if( chara[which].FaceDirect==1 ){
								chara[which].PixelOffsetX=(24/myac.arg2)*(myac.arg2-myac.arg1+1);
								chara[which].PixelOffsetY=0;
							}else if( chara[which].FaceDirect==2 ){
								chara[which].PixelOffsetX=0;
								chara[which].PixelOffsetY=(24/myac.arg2)*(myac.arg2-myac.arg1+1);
							}else if( chara[which].FaceDirect==3 ){
								chara[which].PixelOffsetX=-(24/myac.arg2)*(myac.arg2-myac.arg1+1);
								chara[which].PixelOffsetY=0;
							}

							chara[which].ActionQueue.front().arg1--;
							if( chara[which].ActionQueue.front().arg1<=0 ){
								chara[which].ActionQueue.pop();
								if( chara[which].FaceDirect==0 ){
									Y--;
								}else if( chara[which].FaceDirect==1 ){
									X++;
								}else if( chara[which].FaceDirect==2 ){
									Y++;
								}else if( chara[which].FaceDirect==3 ){
									X--;
								}
								chara[which].PixelOffsetX=chara[which].PixelOffsetY=0;
								chara[which].AniImage[chara[which].NowPlayIndex].Enabled=false;
								if( which==0 ){
									if( MapData[X][Y].objflag==0 ){
										static int objvalid;
										static char sendtmp[32];
//										objvalid=ObtainObject(i,MapData[X][Y].objflag,charax,charay);
  //										if( objvalid==1 ){
											MapData[X][Y].objflag=-1;
//										}
//										sprintf(sendtmp,"@getobj,%d,%d",X,Y);
//										Global_SendData(sendtmp);
										chara[0].numobj++;


									}
								}
/*										if( LockCamera==true )
									ViewMe();*/
							}
						}
						return;
					case _JumpUp:
						chara[which].ActionQueue.front().arg1++;
						double mgy;
						if( chara[which].ActionQueue.front().arg1>4 )
							mgy=-0.5f*12.0-0.5f*6.8f*4.0*4.0+0.5f*9.8f*(chara[which].ActionQueue.front().arg1-4)*(chara[which].ActionQueue.front().arg1-4);//(int) (-0.5f*10.0f*5 +0.5f*10.0f*(chara[which].ActionQueue.front().arg1-5) ) ;
						else
							mgy=-0.5f*chara[which].ActionQueue.front().arg1-0.5f*6.8f*chara[which].ActionQueue.front().arg1*chara[which].ActionQueue.front().arg1;
						chara[which].PixelOffsetY=(int)(mgy/5.0);
						if(	chara[which].ActionQueue.front().arg1>=8){
							chara[which].PixelOffsetY=0;
							chara[which].ActionQueue.pop();
						}
						return;
				}
			}
		}
		int AssignUniqueID(int uniqueid,bool IsMainChara)
		{
			if( IsMainChara ){
				chara[0].uniqueid=uniqueid;
				return 0;
			}else{
				int i;
				for(i=1;i<32;i++){
					if( chara[i].Exist==false ){
						chara[i].uniqueid=uniqueid;
						chara[i].Exist=true;
						return i;
					}//if
				}//for
			}
			return -1;
		}
		int FindUniqueID(int uniqueid)
		{
			int i;
			for(i=0;i<32;i++){
				if( chara[i].Exist && chara[i].uniqueid==uniqueid ){
					return i;
				}
			}
			return -1;
		}
		void DrawObject(int whichobj,int X,int Y,bool TimeFlag)
		{
			int i,j,k,objx,objy;
			int z;
			bmpBuffer->TransparentMode=tmAuto;
			bmpBuffer->Transparent=true;
			
			for(i=whichobj;i<whichobj+1;i++){
				if( obj[i].Exist ){
				z=obj[i].NowPlayIndex;
//				if( z!=2 ) ShowMessage("!");
				//Hgridy
				objx=X;
				objy=Y;
				if( obj[i].Visible==true ){//&& nowTickCount - obj[i].AniImage[z].TickCount >= obj[i].AniImage[z].Interval ){
//					MapImage->Canvas->TextOut(0,0,"Hello!");
					//i&&Fframe iterval time, ~øsframe
					if( obj[i].AniImage[z].Enabled==true ){
						//ӰʵeQ]
						//oʵeثeframe image

						obj[i].AniImage[z].GetFrameImage(obj[i].AniImage[z].PlayingIndex,bmpBuffer);
						if( objx>=svX && objy>=svY && objx-svX<MaxViewWidth && objy-svY<MaxViewHeight ){
							MapImage->Canvas->Draw( (objx-svX)*GridPixelWidth ,
										(objy-svY)*GridPixelHeight - (bmpBuffer->Height - GridPixelHeight)  ,
										bmpBuffer );
						}
						if( obj[i].TimeFlag==TimeFlag ){
							obj[i].AniImage[z].PlayingIndex++;
							obj[i].AniImage[z].PlayingIndex=obj[i].AniImage[z].PlayingIndex % obj[i].AniImage[z].Amount;							
							obj[i].TimeFlag=!obj[i].TimeFlag;
						}
						bmpBuffer->Transparent=false;
					}else{
						//ӹϤQ]R
						//uøsindex==LockAtFrameframe
//						bmpBuffer->TransparentMode=tmAuto;
//						bmpBuffer->Transparent=true;
						obj[i].AniImage[z].GetFrameImage(obj[i].AniImage[z].LockAtIndex,bmpBuffer);
						if( objx>=svX && objy>=svY && objx-svX<MaxViewWidth && objy-svY<MaxViewHeight ){
							MapImage->Canvas->Draw( (objx-svX)*GridPixelWidth  ,
											(objy-svY)*GridPixelHeight - (bmpBuffer->Height - GridPixelHeight) ,
											bmpBuffer );
						}

					}
					//ެOOEnablednsOɶA
					//obj[i].AniImage[z].TickCount=nowTickCount;
				}//if
			}//for
			}//if(exist)
			bmpBuffer->Transparent=false;			
		}
		int ObtainObject(int which_chara,int which_object,int X,int Y)
		{
        	
			return 1;
		}
		void RedrawMapImage()
		{
			//øӦa
			
			int i,j,k,nx,ny;
			static int prevTickCount,nowTickCount,mySec;
			static bool TimeFlag;
			int OffsetX,OffsetY,z,charax,charay;
			bool changed;
			TimeFlag=!TimeFlag;
			//øsaϤ@@檺
			MapImage->Canvas->Brush->Style=bsSolid;
			MapImage->Canvas->Brush->Color=clWhite;
//			MapImage->Canvas->FillRect(Rect(0,0,450,384));
			myImageArrayLoader *gridtexture;
			for(j=svY;j<svY+MaxViewHeight&&j<MaxMapH;j++){
				for(i=svX;i<svX+MaxViewWidth&&i<MaxMapW;i++){
						gridtexture = &GridImage[MapData[i][j].Index] ;
						gridtexture->GetSubImage( MapData[i][j].X , MapData[i][j].Y , bmpBuffer );
						MapImage->Canvas->CopyRect(
									Rect((i-svX)*GridPixelWidth,(j-svY)*GridPixelHeight,(i-svX+1)*GridPixelWidth,(j-svY+1)*GridPixelHeight),
									bmpBuffer->Canvas,
									Rect(0,0,bmpBuffer->Width,bmpBuffer->Height) );
  						if( MapData[i][j].objflag!=-1 )
							DrawObject(MapData[i][j].objflag,i,j,TimeFlag);
					}
			}
//			return;

			nowTickCount= GetTickCount() ;
			if( nowTickCount-prevTickCount >= 60 ){
				//øsHʵe
				for(i=0;i<32;i++){
					if( chara[i].Exist ){
					z=chara[i].NowPlayIndex;
					//Hgridy
					charax=chara[i].X;
					charay=chara[i].Y;
					//ˬdO_즳objecta
/*					if( i==0 && MapData[charax][charay].objflag!=-1 ){
						static int objvalid;
						static char sendtmp[32];
						objvalid=ObtainObject(i,MapData[charax][charay].objflag,charax,charay);
						if( objvalid==1 ){
							MapData[charax][charay].objflag=-1;
						}
						sprintf(sendtmp,"@getobj,%d,%d",charax,charay);
						Global_SendData(sendtmp);
						chara[0].numobj++;
					}*/
					//---
					if( chara[i].Visible==true && nowTickCount - chara[i].AniImage[z].TickCount >= chara[i].AniImage[z].Interval ){
//					MapImage->Canvas->TextOut(0,0,"Hello!");
						//i&&Fframe iterval time, ~øsframe
						if( chara[i].AniImage[z].Enabled==true ){
							//ӰʵeQ]
							//oʵeثeframe image
							bmpBuffer->TransparentMode=tmAuto;
							bmpBuffer->Transparent=true;
							chara[i].AniImage[z].GetFrameImage(chara[i].AniImage[z].PlayingIndex,bmpBuffer);
							//ebaϤW
/*							MapImage->Canvas->CopyRect(
								Rect(charax*GridPixelWidth,charay*GridPixelHeight,(charax+1)*GridPixelWidth,(charay+1)*GridPixelHeight),
								bmpBuffer->Canvas,
								Rect(0,0,bmpBuffer->Width,bmpBuffer->Height) );*/
							//bd򤺤~øs!
							if( charax>=svX && charay>=svY && charax-svX<MaxViewWidth && charay-svY<MaxViewHeight ){
								MapImage->Canvas->Draw( (charax-svX)*GridPixelWidth + chara[i].PixelOffsetX ,
											(charay-svY)*GridPixelHeight - (bmpBuffer->Height - GridPixelHeight) + chara[i].PixelOffsetY ,
											bmpBuffer );
							}

							chara[i].AniImage[z].PlayingIndex++;
/*							if( chara[i].AniImage[z].Amount==0 ){
							ShowMessage( "erro );
							}*/
							chara[i].AniImage[z].PlayingIndex=chara[i].AniImage[z].PlayingIndex % chara[i].AniImage[z].Amount;
							ExecuteAction(i);
							bmpBuffer->Transparent=false;
						}else{
							//ӹϤQ]R
							//uøsindex==LockAtFrameframe
							bmpBuffer->TransparentMode=tmAuto;
							bmpBuffer->Transparent=true;
							chara[i].AniImage[z].GetFrameImage(chara[i].AniImage[z].LockAtIndex,bmpBuffer);
							if( charax>=svX && charay>=svY && charax-svX<MaxViewWidth && charay-svY<MaxViewHeight ){
								MapImage->Canvas->Draw( (charax-svX)*GridPixelWidth +chara[i].PixelOffsetX ,
												(charay-svY)*GridPixelHeight - (bmpBuffer->Height - GridPixelHeight) +chara[i].PixelOffsetY ,
												bmpBuffer );
							}
							bmpBuffer->Transparent=false;
							ExecuteAction(i);
						}
						//øsHW٦bYW
						if( strlen(chara[i].name)>0 ){
							MapImage->Canvas->Brush->Style=bsClear;
							MapImage->Canvas->Font->Color=clYellow;
							int gx=(charax-svX)*GridPixelWidth -5 ;
							int gy=(charay-svY)*GridPixelHeight - (bmpBuffer->Height - GridPixelHeight) -18;
							MapImage->Canvas->TextOut( gx+1 , gy, chara[i].name );
							MapImage->Canvas->TextOut( gx , gy+1, chara[i].name );
							MapImage->Canvas->TextOut( gx-1 , gy, chara[i].name );
							MapImage->Canvas->TextOut( gx , gy-1, chara[i].name );
							MapImage->Canvas->Font->Color=clBlue;
							MapImage->Canvas->TextOut( gx , gy, chara[i].name );
						}



						//ެOOEnablednsOɶA
						chara[i].AniImage[z].TickCount=nowTickCount;
					}//if
				}//for
				}//if(exist)

				nx = chara[0].X - (MaxViewWidth/2);
				ny = chara[0].Y - (MaxViewHeight/2);
				if( nx<0 ) nx=0;
				if( ny<0 ) ny=0;
				svX=nx;
				svY=ny;


				//øschat msg
				MapImage->Canvas->Font->Size=11;
				for(i=0; i<8 && i<ChatMsgQueue.size();i++){
					MapImage->Canvas->TextOut( 230,10+i*MapImage->Canvas->TextHeight(ChatMsgQueue[i])
									,ChatMsgQueue[i]);
				}
				// øsǽsT
//				MapImage->Canvas->Font->Size=9;
//				MapImage->Canvas->Font->Color=RGB(231+rand()%20,223+rand()%20,254+rand());
//				MapImage->Canvas->TextOut(100,0,"TinyNetWorkRPG");
/*				static char numobjstr[20];
				sprintf(numobjstr,"%d",chara[0].numobj);
				bmpBuffer->TransparentMode=tmAuto;
				bmpBuffer->Transparent=true;
				for(i=0,j=0;i<strlen(numobjstr);i++){
					if( isdigit(numobjstr[i]) ){
						OtherImage[0].GetSubImage(numobjstr[i]-'0'+1,1,bmpBuffer);
						MapImage->Canvas->Draw(380+j*OtherImage[0].subWidth,0,bmpBuffer);
						j++;
					}
				}
				MapImage->Canvas->Font->Size=12;
//				MapImage->Canvas->Font->Color=clBlue;
				MapImage->Canvas->TextOut(300,5,"o_");
				bmpBuffer->Transparent=false;    */


//				MapImage->Canvas->Draw(0,0,FrameEdgeImage);
				prevTickCount=nowTickCount;
			}




		}
		void Net_SCXY(char* buffer,int bufsize)
		{
			//uǰechara[0]yг
			//C2s@
			// set character x,y
			sprintf(buffer,"@scxy,%d,%d",chara[0].X,chara[0].Y);
		}
		void Net_SVXY(char* buffer,int bufsize)
		{
			// set viewrect x,y
			sprintf(buffer,"@svxy,%d,%d",svX,svY);
		}
		
};

#endif
